# coding: utf-8

from java.text import SimpleDateFormat
from java.util import ArrayList
import json

from edu._edu_orm import vw_course_cycleCursor
from ru.curs.celesta.showcase.utils import XMLJSONConverter


try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO



def cycleList(context, main=None, add=None, filterinfo=None, session=None, params=None,
              curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    '''Список циклов'''
    cycle = vw_course_cycleCursor(context)

    if params:
        filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]

        if not isinstance(filter_data, list):
            filter_data = [filter_data]

        for filter_item in filter_data:
            if filter_item.get("course_id"):
                cycle.setRange("course_id", filter_item["course_id"])

    cycle.orderBy('start_date')
#     cycle.setFilter('start_date', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    cycle.limit(firstRecord, recordCount)

    recordList = ArrayList()
    df = SimpleDateFormat("dd.MM.yyyy")
    for cycle in cycle.iterate():
        record = DataRecord()

        record.id = str(cycle.uid)
        record.name = u'%s - %s (%s ч)' % (df.format(cycle.start_date) if cycle.start_date else '',
                                           df.format(cycle.end_date) if cycle.end_date else '',
                                           cycle.course_hours)

        recordList.add(record)

    return ResultSelectorData(recordList, 0)

def cycleCount(context, main=None, add=None, filterinfo=None, session=None, params=None,
               curValue=None, startsWith=None):
    '''Счетчик циклов'''

    cycle = vw_course_cycleCursor(context)

    if params:
        filter_data = json.loads(XMLJSONConverter.xmlToJson(params))["schema"]["filter"]

        if not isinstance(filter_data, list):
            filter_data = [filter_data]

        for filter_item in filter_data:
            if filter_item.get("course_id"):
                cycle.setRange("course_id", filter_item["course_id"])

#     cycle.setFilter('name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))

    count = cycle.count()

    return ResultSelectorData(None, count)
